libstdc++: std::_List_iterator< _Tp > Struct Template Reference

libstdc++

std::_List_iterator< _Tp > Struct Template Reference

`#include <stl_list.h>`

## Public Types
typedef _List_node< _Tp > | _Node
typedef ptrdiff_t | difference_type
typedef std::bidirectional_iterator_tag | iterator_category
typedef _Tp * | pointer
typedef _Tp & | reference
typedef _Tp | value_type

## Public Member Functions
| _List_iterator (__detail::_List_node_base *__x) noexcept
_List_iterator | _M_const_cast () const noexcept
reference | operator* () const noexcept
_List_iterator & | operator++ () noexcept
_List_iterator | operator++ (int) noexcept
_List_iterator & | operator-- () noexcept
_List_iterator | operator-- (int) noexcept
pointer | operator-> () const noexcept

## Public Attributes
__detail::_List_node_base * | _M_node

## Friends
bool | operator== (const _List_iterator &__x, const _List_iterator &__y) noexcept

## Detailed Description

template<typename _Tp>
struct std::_List_iterator< _Tp >

A list::iterator.

All the functions are op overloads.

Definition at line 574 of file stl_list.h.

## Member Typedef Documentation

## ◆ _Node

template<typename _Tp>

typedef _List_node<_Tp> std::_List_iterator< _Tp >::_Node

Definition at line 576 of file stl_list.h.

## ◆ difference_type

template<typename _Tp>

typedef ptrdiff_t std::_List_iterator< _Tp >::difference_type

Definition at line 578 of file stl_list.h.

## ◆ iterator_category

template<typename _Tp>

typedef std::bidirectional_iterator_tag std::_List_iterator< _Tp >::iterator_category

Definition at line 579 of file stl_list.h.

## ◆ pointer

template<typename _Tp>

typedef _Tp* std::_List_iterator< _Tp >::pointer

Definition at line 581 of file stl_list.h.

## ◆ reference

template<typename _Tp>

typedef _Tp& std::_List_iterator< _Tp >::reference

Definition at line 582 of file stl_list.h.

## ◆ value_type

template<typename _Tp>

typedef _Tp std::_List_iterator< _Tp >::value_type

Definition at line 580 of file stl_list.h.

## Constructor & Destructor Documentation

## ◆ _List_iterator() [1/2]

template<typename _Tp>

std::_List_iterator< _Tp >::_List_iterator | ( |  | ) |
| inline noexcept

Definition at line 584 of file stl_list.h.

## ◆ _List_iterator() [2/2]

template<typename _Tp>

std::_List_iterator< _Tp >::_List_iterator | ( | __detail::_List_node_base * | __x | ) |
| inline explicit noexcept

Definition at line 588 of file stl_list.h.

## Member Function Documentation

## ◆ _M_const_cast()

template<typename _Tp>

_List_iterator std::_List_iterator< _Tp >::_M_const_cast | ( |  | ) | const
| inline noexcept

Definition at line 592 of file stl_list.h.

## ◆ operator*()

template<typename _Tp>

reference std::_List_iterator< _Tp >::operator* | ( |  | ) | const
| inline nodiscard noexcept

Definition at line 598 of file stl_list.h.

## ◆ operator++() [1/2]

template<typename _Tp>

_List_iterator & std::_List_iterator< _Tp >::operator++ | ( |  | ) |
| inline noexcept

Definition at line 607 of file stl_list.h.

## ◆ operator++() [2/2]

template<typename _Tp>

_List_iterator std::_List_iterator< _Tp >::operator++ | ( | int |  | ) |
| inline noexcept

Definition at line 614 of file stl_list.h.

## ◆ operator--() [1/2]

template<typename _Tp>

_List_iterator & std::_List_iterator< _Tp >::operator-- | ( |  | ) |
| inline noexcept

Definition at line 622 of file stl_list.h.

## ◆ operator--() [2/2]

template<typename _Tp>

_List_iterator std::_List_iterator< _Tp >::operator-- | ( | int |  | ) |
| inline noexcept

Definition at line 629 of file stl_list.h.

## ◆ operator->()

template<typename _Tp>

pointer std::_List_iterator< _Tp >::operator-> | ( |  | ) | const
| inline nodiscard noexcept

Definition at line 603 of file stl_list.h.

## Friends And Related Symbol Documentation

## ◆ operator==

template<typename _Tp>

bool operator== | ( | const _List_iterator< _Tp > & | __x,
|  | const _List_iterator< _Tp > & | __y )
| friend

Definition at line 638 of file stl_list.h.

## Member Data Documentation

## ◆ _M_node

template<typename _Tp>

__detail::_List_node_base* std::_List_iterator< _Tp >::_M_node

Definition at line 651 of file stl_list.h.

The documentation for this struct was generated from the following files:

- stl_iterator_base_funcs.h
- stl_list.h